##############################################################################
# Copyright (c) 2004-2005 Black Rock City, LLC
# Copyright (c) 2004-2005 ObjectRealms, LLC
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
##############################################################################
"""
$Id: storage.py 576 2005-01-20 19:14:56Z hazmat $
"""

from Products.Archetypes.Storage import MementoStorage
from Products.CMFMember.Member import Member

from Products.TeamSpace.zimport import *

class TeamMembershipStorage(MementoStorage):
    """
    Annotation storage of the member's team data unto the
    membership object of that member in the team
    """
    
    def __init__(self):
        pass

    def _memento(self, instance):
        assert isinstance( instance, Member), " random object not allowed"
        container = aq_parent( aq_inner( self ) )
        member_id = instance.getId()
        membership = container.getMemberById( member_id )
        return membership._annotations
    
    def get(self, name, instance, **kwargs):
        m = self._memento(instance)
        return m[name]

    def set(self, name, instance, value, **kwargs):
        # Remove acquisition wrappers
        m = self._memento(instance)
        m[name] = value
        instance._p_changed = 1
        
    def unset(self, name, instance, **kwargs):
        m = self._memento(instance)
        del m[name]
        instance._p_changed = 1

from Products.Archetypes.Registry import registerStorage
registerStorage( TeamMembershipStorage )
